import datetime
import time
import msvcrt
import curses
import ctypes
import os
import threading
from time import sleep
from time import strftime
from datetime import datetime
from array import array          

version = "v1"               # first release
# NOTE:
# set screen width/height - MUST come BEFORE curses.initscr()
# else curses screen and buffer size will not match console

SCRN_WIDTH = 140
strMode = "mode con: cols=%d lines=53" % SCRN_WIDTH
os.system(strMode)

stdscr = curses.initscr()
stdscr.keypad(1)
curses.cbreak(); curses.echo(); curses.curs_set(0)
FALSE = 0; false = 0; TRUE = 1; true = 1
usDevID = ctypes.c_ushort(0)
psDevListSave=(ctypes.c_ushort*32)(0)
psDevListNew=(ctypes.c_ushort*32)(0)

bDigout = ctypes.c_ubyte; bDigout = 0
bDigoutSent = ctypes.c_ubyte; bDigoutSent = 0

bDigin = ctypes.c_ubyte; bDigin = 0
bDiginRead = ctypes.c_ubyte; bDiginRead = 0

bDAC = ctypes.c_ubyte; bDAC = 0
dblAOut = ctypes.c_double; dblAOut = 0
bAnalogSent = ctypes.c_ubyte; bAnalogSent = 0

bCurChan = ctypes.c_ubyte; bCurChan = 0             # for single channel scans or polled mode
bNumChans = ctypes.c_ubyte; bNumChans = 7           # for multi-channel scans
bNumChansTemp = ctypes.c_ubyte; bNumChansTemp = 7   # save multi-channel count when doing single chan    

fRate = ctypes.c_double                             # Internal Data Rate 
fRate = 100
#actual rate for precision timing
fActualRate = ctypes.c_double
fActualRate = 100
bSendRateQuiet = ctypes.c_ubyte; bSendRateQuiet = 0  # used during initialization

bScanType = ctypes.c_ubyte; bScanType = 6

bIsScanning = ctypes.c_ubyte; bIsScanning = 0        #  Flags
fCal = ctypes.c_ubyte; fCal=1                        #  Flags calibration scan
fSingle = ctypes.c_ubyte; fSingle=0                  #  Flags single channel scan
fDig = ctypes.c_ubyte; fDig=0                        #  Flags digital input scan

fDoLog = ctypes.c_ubyte; fDoLog=0                    #  Flags data file
fDoScreen = ctypes.c_ubyte; fDoScreen=1              #  Flags screen writing

bLocAvg = ctypes.c_ubyte; bLocAvg=1         

ScanNumber = ctypes.c_uint; ScanNumber = 0


stypestr = ["NUL", "SINGLE CHANNEL SCAN ", "MULTI-CHANNEL SCAN ", "MULTI-CHANNEL CAL SCAN ","SINGLE CHANNEL DIGIN SCAN ", "MULTI-CHANNEL DIGIN SCAN ", "MULTI-CHANNEL CAL DIGIN SCAN " ]

CMND_SINGLE_CHAN_SCAN = 0x1
CMND_MULTI_CHAN_SCAN = 0x2 
CMND_MULTI_CHAN_CAL_SCAN = 0x3 
CMND_SINGLE_CHAN_DIGIN_SCAN = 0x4 
CMND_MULTI_CHAN_DIGIN_SCAN = 0x5 
CMND_MULTI_CHAN_CAL_DIGIN_SCAN = 0x6 



#===================================================================================
#===================================================================================
#==== S C A N - R E L A T E D   F U N C T I O N s ==================================
#===================================================================================
#===================================================================================

def scanFunc():
  global LL_USB_Lib
  global usDevID
  global bIsScanning
  global bNumChans
  global bNumChansTemp, fDoLog, fDoScreen, fileName
  global ScanNumber, dataPnt, AvgArray, AvgTot

  AvgTot = array('f',[0,0,0,0,0,0,0,0])   # total for each channel - divide by bLocAvg for answer 

  AvgArray = array('f',[0])               # synthesized multi-channel array for averaging scan data
  for n in range (bLocAvg * 8):
    AvgArray.append (0)

  ScanNumber = 0
  bErrorType = ctypes.c_ubyte(0)
  bGotDevError = ctypes.c_ubyte; bGotDevError = 0
  pfStillScanning = ctypes.c_ubyte()
  puiStatusCode = ctypes.c_uint()
  
  if(fDoLog):                       # open log file
    file_path = ".\\scanLog\\"
    directory = os.path.dirname(file_path)
    try: os.stat(directory)
    except: os.mkdir(directory)       
    fileName = (".\\scanLog\\%s.txt" % (datetime.now().strftime('%Y-%m-%d_%H-%M-%S')))
    file = open(fileName,"w", 0)
     
  top = 1
  #clear screen
  for x in range(0, 50): 
    stdscr.move(x, 0)
    erase(SCRN_WIDTH) 
  stdscr.refresh(); 
  strSimpMenu = "E)End scan    O)digital Output    A)Analog output"
  stdscr.move(top, 1);stdscr.addstr(strSimpMenu)                  # Commands active during scanning        
  if(fSingle): stdscr.addstr("    C)Change channel")
  if(fDoLog): stdscr.addstr ("    logging to file:  \"%s\")" % fileName)
  if not(fDoScreen): stdscr.addstr ("    no screen display of data)") 
  stdscr.refresh();

  
  #BOOLEAN EX_SetScanType ( USHORT usDevID, BYTE bScanType );
  LL_USB_Lib.EX_SetScanType.argtypes = [ctypes.c_ushort, ctypes.c_ubyte]
  LL_USB_Lib.EX_SetScanType.restypes = ctypes.c_ubyte
  if LL_USB_Lib.EX_SetScanType(usDevID, bScanType): pass
  else:
    stdscr.move(top + 1, 0);
    stdscr.addstr ("failed scan type set. <ENTER> to exit scan: "); stdscr.refresh()
    var = stdscr.getstr()
    return

  #BOOLEAN EX_SetDataLogOptions ( USHORT usDevID, UINT uiDataLogMethod, UINT uiLogFileMaxSize, UINT uiMisc );
  # scan data log options from API documentation
  SCAN_USE_DATA_LOG_FILE = 0x1
  SCAN_USE_DATA_ARRAY = 0x2
  SCAN_STOP_ON_DATA_ARRAY_WRAP = 0x4
  SCAN_LIMIT_LOG_FILE_SIZE = 0x8
  uiDataLogMethod = ctypes.c_uint(SCAN_USE_DATA_ARRAY) #to log to file too, add:  " | SCAN_USE_DATA_LOG_FILE"
  LL_USB_Lib.EX_SetDataLogOptions.argtypes = [ctypes.c_ushort, ctypes.c_uint, ctypes.c_uint, ctypes.c_uint]
  LL_USB_Lib.EX_SetDataLogOptions.restypes = ctypes.c_ubyte
  if LL_USB_Lib.EX_SetDataLogOptions(usDevID, uiDataLogMethod, 0, 0): pass
  else:
    stdscr.move(top + 1, 0);
    stdscr.addstr ("failed scan data log options set. <ENTER> to exit scan: "); stdscr.refresh()
    var = stdscr.getstr()
    return

  #BOOLEAN EX_SetMultiChanScanChans ( USHORT usDevID, BYTE bChanCnt ); 
  LL_USB_Lib.EX_SetMultiChanScanChans.argtypes = [ctypes.c_ushort, ctypes.c_ubyte]
  LL_USB_Lib.EX_SetMultiChanScanChans.restypes = ctypes.c_ubyte
  if LL_USB_Lib.EX_SetMultiChanScanChans(usDevID, bNumChans): pass
  else:
    stdscr.move(top + 1, 0);
    stdscr.addstr ("failed scan data log options set. <ENTER> to exit scan: "); stdscr.refresh()
    var = stdscr.getstr(); return
 
  #BOOLEAN EX_Run ( USHORT usDevID );
  LL_USB_Lib.EX_Run.argtypes = [ctypes.c_ushort]
  LL_USB_Lib.EX_Run.restypes = ctypes.c_ubyte
  if LL_USB_Lib.EX_Run(usDevID): pass
  else:
    stdscr.move(top + 1, 0);
    stdscr.addstr ("failed EX_Run. <ENTER> to exit scan: ");
    var = stdscr.getstr(); return
    return

  startTime=time.strftime("%m-%d-%y %H:%M:%S")
  STime=time.time()
  
  #BOOLEAN EX_CheckScanStatus ( USHORT usDevID, UINT* puiNumScansRemainingInBuff, BOOLEAN* pfStillScanning, UINT* puiStatusCode) );
  LL_USB_Lib.EX_CheckScanStatus.argtypes = [ctypes.c_ushort, ctypes.POINTER(ctypes.c_uint), ctypes.POINTER(ctypes.c_ubyte), ctypes.POINTER(ctypes.c_uint)]
  LL_USB_Lib.EX_CheckScanStatus.restypes = ctypes.c_ubyte

  pdblDataBuff=(ctypes.c_double*1600)()
  pbDiginBuff=(ctypes.c_ubyte*1600)()

  uiNumScansToReturn = ctypes.c_uint()       # maximun number of scans to collect in one call to GetScanData
  fGetAllRequested = ctypes.c_ubyte
  fGetAllRequested = 0                       # return with however many scans are ready, up to maximum
  puiNumScansReturned = ctypes.c_uint()
 
  array_of_size_uint = ctypes.c_uint*1
  puiTotalBuffSize = array_of_size_uint()
  puiTotalBuffSize[0]=400

  puiNumScansRemainingInBuff = ctypes.c_uint()  # should be 0 if you are keeping up with the data
 
  #BOOLEAN EX_GetScanDataDblDigin ( USHORT usDevID, double* pdblDataBuff, BYTE* pbDiginBuff,
  #                              UINT uiNumScansToReturn, BOOLEAN fGetAllRequested, UINT* puiNumScansReturned,
  #                              UINT* puiNumScansRemainingInBuff, BOOLEAN* pfStillScanning, UINT* puiTotalBuffSize, UINT* puiErrCode); 
  LL_USB_Lib.EX_GetScanDataDblDigin.argtypes = [ctypes.c_ushort, ctypes.POINTER(ctypes.c_double), ctypes.POINTER(ctypes.c_ubyte), ctypes.c_uint, ctypes.c_ubyte, \
    ctypes.POINTER(ctypes.c_uint), ctypes.POINTER(ctypes.c_uint), ctypes.POINTER(ctypes.c_ubyte), ctypes.POINTER(ctypes.c_uint), ctypes.POINTER(ctypes.c_uint)]
  LL_USB_Lib.EX_GetScanDataDblDigin.restypes = ctypes.c_ubyte
  #BOOLEAN EX_GetScanDataDbl(USHORT usDevID, double* pdblDataBuff, UINT uiNumScansToReturn, BOOLEAN fGetAllRequested,
  #                          UINT* puiNumScansReturned, UINT* puiNumScansRemainingInBuff, BOOLEAN* pfStillScanning,
  #                          UINT* puiTotalBuffSize, UINT* puiErrCode)
  LL_USB_Lib.EX_GetScanDataDbl.argtypes = [ctypes.c_ushort, ctypes.POINTER(ctypes.c_double), ctypes.c_uint, ctypes.c_ubyte, \
    ctypes.POINTER(ctypes.c_uint), ctypes.POINTER(ctypes.c_uint), ctypes.POINTER(ctypes.c_ubyte), ctypes.POINTER(ctypes.c_uint), ctypes.POINTER(ctypes.c_uint)]
  LL_USB_Lib.EX_GetScanDataDbl.restypes = ctypes.c_ubyte


# Now, write column labels to screen and file, as appropriate
  stdscr.move(top + 1, 0); stdscr.addstr(" Doing %s:      Start Time: %s" % (stypestr[bScanType], startTime))
  stdscr.move(top + 2, 0); stdscr.addstr("    scan#  ")
  if(fDoLog): file.write("    scan#  ")   
  if(fSingle):
    stdscr.addstr(" Chan %d    " % bCurChan)
    if(fDig): stdscr.addstr(" DI ")
    if(fDoLog):
      file.write(" Chan %d" % bCurChan)   
      if(fDig): file.write(" DI ")
  else:
    for x in range(0, bNumChans):
      stdscr.addstr("   Chan %d  " % x)
      if(fDoLog): file.write("   Chan %d  " % x) 
      if(fDig):
        stdscr.addstr(" DI ")
        if(fDoLog): file.write(" DI ") 
  if(fCal):
    stdscr.addstr("   offset  ")
    if(fDoLog): file.write("   offset  ") 
    if(fDig):
      stdscr.addstr(" DI ")
      if(fDoLog): file.write(" DI ") 
  stdscr.addstr("  buff  ")
  if(fDoLog):
    file.write("\n"); file.flush()
    
  bCurRow = ctypes.c_ubyte; bCurRow = top + 4
  endScan = ctypes.c_ubyte; endScan = 0
  bRetVal = ctypes.c_ubyte; bRetVal = 0
  bIsScanning = 1                 # flag used mostly for screen locations
  
  while (1==1):
    keyhit =""
    if msvcrt.kbhit():
      keyhit= msvcrt.getch()
      keyhit = keyhit.upper()
    if keyhit == b"E":
      stdscr.move(51, 0); erase(SCRN_WIDTH); stdscr.refresh(); stdscr.move(51, 0)
      stdscr.addstr ("ending scan - wait . . . ")
      break
    if (keyhit == b"C" and fSingle): #only valid in single channel type scans
      doSendChan();
    if keyhit == b"O":
      doDigout()
    if (keyhit == b"A"):
      doAnalogout()
        
    if LL_USB_Lib.EX_CheckScanStatus(usDevID, puiNumScansRemainingInBuff, pfStillScanning, puiStatusCode):
      if(pfStillScanning == 0):
        print ("  scan stopped\n")
        break #still need to stop/complete scan
    else:
      stdscr.move(49, 0); erase(SCRN_WIDTH); stdscr.refresh(); 
      stdscr.move(49, 0); stdscr.addstr("failed EX_CheckScanStatus - may have lost connection or power - return to main menu")
      stdscr.refresh();
      bGotDevError = 1
      break #still need to stop/complete scan

    if(fSingle):
      uiNumScansToReturn = 50                   # optimize these two values for your system and application
    else:                                       # getting more scans at one time is more efficient, but
      uiNumScansToReturn = 8                    # can increase latency
    
    if (puiNumScansRemainingInBuff.value >= 1): # at least one scan is ready to read
      if(fDig):
        bRetVal = LL_USB_Lib.EX_GetScanDataDblDigin(usDevID, pdblDataBuff, pbDiginBuff, uiNumScansToReturn, fGetAllRequested, \
                      puiNumScansReturned, puiNumScansRemainingInBuff, pfStillScanning, puiTotalBuffSize, puiStatusCode)
      else:
        bRetVal = LL_USB_Lib.EX_GetScanDataDbl(usDevID, pdblDataBuff, uiNumScansToReturn, fGetAllRequested, \
                      puiNumScansReturned, puiNumScansRemainingInBuff, pfStillScanning, puiTotalBuffSize, puiStatusCode)
      if(bRetVal):


        # This routine is used for all scanning. It accepts input of one or more scans
        # as specified by puiNumScansReturned. Data is removed from the buffer and displayed on the screen
        # and/or sent to a data file based on the flags fDoScreen and fDoLog. Flags fCal and fDig are set to
        # match the scan type so that offset and digital input data are handled appropriately. Function doAvg
        # performs running average on LocAvg scans
          
        for n in range (0, puiNumScansReturned.value):            #loop through for all scans
          if(fDoScreen):
            stdscr.move(bCurRow, 0)                               # for screen display only 
            stdscr.addstr ("{:8d}    ".format(ScanNumber))        # display scan number on screen
          if(fDoLog):  
            file.write("{:8d}    ".format(ScanNumber))            # write scan number to file
          ScanNumber = ScanNumber + 1   
          base = int(n * (bNumChans + fCal))                      # pointer into scan array 
          if(fCal): offset= float(pdblDataBuff[base + bNumChans]) # get offset, if cal scan
          for x in range(0, bNumChans):                           # loop through all scan channels
            
            dataPnt = float(pdblDataBuff[base + x])               # get datapoint
            if(fCal): dataPnt = dataPnt - offset                  # subtract offset, if cal scan
            dataPnt =doAvg(dataPnt,x)                             # do runningaverage, initialize if first time, only  #telM
            if(fDig): DigIn = pbDiginBuff[base + x]               # get DigIn, if active 
            if(fDoScreen):                                        
              stdscr.addstr ("{: 5f}  ".format(dataPnt))          # display results
              if(fDig): stdscr.addstr ("{:2d}  ".format(DigIn))
            if(fDoLog):
              file.write("{: 5f}  ".format(float(dataPnt)))       # write results to file 
              if(fDig): file.write("{:2d}  ".format(DigIn))
          if(fDoScreen):                                          # done with all channels except offset
            if(fCal):
              stdscr.addstr ("{: 5f}  ".format(offset))           # if calscan print offset and DigIn,       
              if(fDig): stdscr.addstr ("{:2d}  ".format(pbDiginBuff[base + bNumChans]))   # if active
            stdscr.addstr ("%5d" % puiNumScansRemainingInBuff.value)  # just to warn if falling behind the data 
            stdscr.refresh()  
            bCurRow += 1                                          # housekeeping for screen     
            if(bCurRow > 47): bCurRow = top + 4
          if(fDoLog):                                             # finish writing scan to log file
            if(fCal):
              file.write("{: 5f}  ".format(offset))               # if calscan write offset and DigIn,
              if(fDig): file.write("{:2d}  ".format(pbDiginBuff[base + bNumChans]))      # if active
            file.write("\n")                                      # new line in file

        stdscr.refresh()

        # end of scanloop

  #BOOLEAN EX_Stop ( USHORT usDevID ); 
  LL_USB_Lib.EX_Stop.argtypes = [ctypes.c_ushort]
  LL_USB_Lib.EX_Stop.restypes = ctypes.c_ubyte
  stdscr.move(49, 0); erase(SCRN_WIDTH); stdscr.refresh(); stdscr.move(49, 0)
  stdscr.addstr ("calling EX_Stop . . .")
  EndTime=time.strftime("%m-%d-%y %H:%M:%S")
  ETime=time.time()
  if LL_USB_Lib.EX_Stop(usDevID):
    stdscr.move(49, 0); erase(SCRN_WIDTH); stdscr.refresh(); stdscr.move(49, 0)
    stdscr.addstr ("  EX_Stop success")

   #BOOLEAN EX_StopComplete ( USHORT usDevID );
    LL_USB_Lib.EX_StopComplete.argtypes = [ctypes.c_ushort]
    LL_USB_Lib.EX_StopComplete.restypes = ctypes.c_ubyte
    stdscr.move(49, 0); erase(SCRN_WIDTH); stdscr.refresh(); stdscr.move(49, 0)
    stdscr.addstr ("calling EX_StopComplete . . .")
    endTime=time.strftime("%m-%d-%y %H:%M:%S")
    if LL_USB_Lib.EX_StopComplete(usDevID):
      stdscr.move(49, 0); erase(SCRN_WIDTH); stdscr.refresh(); stdscr.move(49, 0)
      stdscr.addstr ("  EX_StopComplete success")
    
  else:
    stdscr.move(49, 0); erase(SCRN_WIDTH); stdscr.refresh(); stdscr.move(49, 0)
    stdscr.addstr ("  Failed EX_Stop")
    bIsScanning = 0

  if(fDoLog):
    file.write("\nAveraging: %d" % bLocAvg)
    file.write("\nInternal Data Rate: %.2f" % fActualRate)
    file.write("\nScan Rate: %f" % (fActualRate/((bNumChans + fCal) * 5)))
    file.write("\nStarted: %s" % startTime)
    file.write("\nFinished: %s" % endTime)
    file.write("\nElapsed: %9.0f  seconds" % (ETime - STime))
    file.close()
  if(fSingle): bNumChans = bNumChansTemp    #tel restore channel count for multichannel scans
  return

 

def setNumScanChans():
  global LL_USB_Lib, bScanType, bNumChans, bNumChansTemp
  
  #timO3 stdscr.move(28, 0); erase(SCRN_WIDTH); stdscr.refresh(); stdscr.move(28, 0)
  if fSingle:
    stdscr.move(40, 0);
    stdscr.addstr( "always 1 channel when doing a single-channel scan")
    stdscr.refresh()
    return
  while(true):
    stdscr.move(40, 0); erase(SCRN_WIDTH); stdscr.refresh(); stdscr.move(40, 0)
    if fCal:
      stdscr.addstr( "enter number of channels to scan (not including offset channel): ")
    else:
      stdscr.addstr( "enter number of channels to scan (1-8): ")
    curses.curs_set(1)
    stdscr.refresh()
    var = stdscr.getstr()
    curses.curs_set(0)
    try: bNumChansTemp = int(var)
    except: continue

    if fCal:
      if(bNumChansTemp > 7): continue
    else:
      if(bNumChansTemp > 8): continue
    
    bNumChans = bNumChansTemp
    stdscr.move(40, 0); erase(SCRN_WIDTH); stdscr.refresh()
    break
  curses.curs_set(0)



def setScanType():
  global LL_USB_Lib
  global bScanType
  global bNumChans
  global fSingle, fCal, fDig
  
  bScanTypeTemp = ctypes.c_ubyte; bScanTypeTemp = 0
 
  for x in range(0, 49): 
    stdscr.move(x, 0)
    erase(SCRN_WIDTH)                                                                                                                                       
  stdscr.refresh(); 
  stdscr.move(12, 0);

  for x in range(1, 7):                   
    stdscr.addstr (" %d =  " %x)
    stdscr.addstr ("%s \n" % stypestr[x])
  stdscr.refresh()  

  while(true):
    stdscr.move(19, 0); erase(SCRN_WIDTH); stdscr.refresh() 
    stdscr.move(19, 0); stdscr.addstr ("Enter scan type number: ")
    stdscr.refresh() 
    curses.curs_set(1)
    var = stdscr.getstr()
    curses.curs_set(0)
    try: bScanTypeTemp = int(var)
    except: continue
    if(bScanTypeTemp > 6): continue
    break
  bScanType = bScanTypeTemp
  curses.curs_set(0)
  return



def doAvg(dataPnt, x):                     # datapoint for chan x passed in
  global AvgArray, AvgTot                  # averaged datapoint passed back 
  
  if(ScanNumber == 1):
    for n in range(0, bLocAvg):            # preload average array to first data value
      AvgArray [(n * 8) + x] = dataPnt
    AvgTot[x] = (dataPnt * bLocAvg)        # preload total of those data points 
  else:                                    # (scanNumber MOD LocAvg) is pointer into array  
    AvgTot[x] = AvgTot[x] + dataPnt- AvgArray[((ScanNumber % bLocAvg)* 8) + x]
    AvgArray[((ScanNumber % bLocAvg)* 8) + x] = dataPnt # add new, and subtract old data
    dataPnt= AvgTot[x]/bLocAvg     # then update array value, and return new average
  return float(dataPnt)

    

def setLocalAvg():
  global LL_USB_Lib, bLocAvg
  uLocAvgTemp = ctypes.c_uint; uLocAvgTemp = 1
  while(true):
    stdscr.move(39, 0); erase(SCRN_WIDTH); stdscr.refresh(); stdscr.move(39, 0)
    stdscr.addstr( "enter local average (1-255): ")
    curses.curs_set(1)
    stdscr.refresh()
    var = stdscr.getstr()
    curses.curs_set(0)
    try: uLocAvgTemp = int(var)
    except: continue
    if((uLocAvgTemp > 255) or (uLocAvgTemp < 1)): continue
    break
  stdscr.move(39, 0); erase(SCRN_WIDTH); stdscr.refresh();
  bLocAvg = uLocAvgTemp
  curses.curs_set(0)
  return

#===================================================================================
#===================================================================================
#===============     S C A N    M E N U     ========================================
#===================================================================================
#===================================================================================        

def scanMenu():
  global masterDone, initDone, bNumChans, bScanType, fDig, fCal, fSingle, bNumChansTemp, fDoScreen, fDoLog
  stdscr.clear()
  stdscr.refresh()
  while(true):
    for x in range(1, 50):    
      stdscr.move(x, 0)
      erase(SCRN_WIDTH) 
    stdscr.refresh(); 
    
    if(bScanType >= 4):
      fDig = 1                              # flag for Digital Input Scan
    else: fDig = 0
    if((bScanType == 3) or (bScanType == 6)):
      fCal = 1                              # flag for Cal Scan  
    else: fCal = 0

    if((bScanType == CMND_SINGLE_CHAN_DIGIN_SCAN) or (bScanType == CMND_SINGLE_CHAN_SCAN)):  
      fSingle = 1                           # flag for single channel scan
      bNumChansTemp = bNumChans             #  preserve channel count for multichannel scans
      bNumChans= 1
    else:
      fSingle = 0
      bNumChans = bNumChansTemp             # save for possible later multi channel scan                 

    stdscr.move(2, 22); stdscr.addstr("Model 30x USB Data Acquisition System ")
    stdscr.move(4, 22); stdscr.addstr("--------- S C A N    M E N U ---------")
    stdscr.move(7, 22); stdscr.addstr( "Q) Quit Program")
    stdscr.move(9, 22); stdscr.addstr( "B) Back to Main Menu")
    stdscr.move(11, 22); stdscr.addstr( "T) Scan Type %s " % stypestr[bScanType])
    stdscr.move(13, 22); stdscr.addstr("N) Number of channels to scan: ")
    if(fSingle):
      stdscr.addstr("1  ")
    else:
      if(fCal): 
        stdscr.addstr(" %d (+ offset)" % bNumChans)           
      else: stdscr.addstr(" %d  " % bNumChans)
    stdscr.move(15, 22); stdscr.addstr( "L) Log scan data to file ")
    if(fDoLog):
      stdscr.addstr( "ON ")
    else:
      stdscr.addstr( "OFF")
    stdscr.move(17, 22);
    stdscr.addstr( "C) Channel number for single-chan scans (currently: %d)  " % bCurChan)
    stdscr.move(19, 22);
    stdscr.addstr( "R) Set internal data rate (currently %3.3fHz)  " % fActualRate)
    stdscr.move(20, 22);
    if(fSingle):
      stdscr.addstr( "    scan rate = internal data rate ")
    else:
      stdscr.addstr( "    scan rate = internal data rate / (5 * numChans) = %3.3fHz " % (fActualRate/((bNumChans + fCal) * 5)))
    stdscr.move(22, 22); stdscr.addstr( "O) Digital output");
    stdscr.move(24, 22); stdscr.addstr( "A) Analog output")
    stdscr.move(26, 22); stdscr.addstr( "X) Screen display ")
    if(fDoScreen):
      stdscr.addstr( "ON ")
    else:
      stdscr.addstr( "OFF")
    stdscr.move(28, 22); stdscr.addstr( "V) Local average: %d   " % bLocAvg) 
    stdscr.move(30, 22); stdscr.addstr( "S) Start scan")
    stdscr.refresh()

    keyhit =""
    while (true):
      if msvcrt.kbhit():
        keyhit= msvcrt.getch()
        keyhit = keyhit.upper()
      if keyhit == b"Q":
        masterDone = 1 #back to main and then exit the app
        return (0)
      if (keyhit == b"B"): return (0)
      if (keyhit == b"T"): setScanType(); break
      if (keyhit == b"N"): setNumScanChans(); break
      if (keyhit == b"L"): fDoLog = not fDoLog; break
      if (keyhit == b"C"): doSendChan(); break
      if (keyhit == b"R"): doSendRate(); break
      if (keyhit == b"O"): doDigout(); break
      if (keyhit == b"A"): doAnalogout(); break
      if (keyhit == b"X"): fDoScreen = not fDoScreen; break
      if (keyhit == b"V"): setLocalAvg(); break  
      if (keyhit == b"S"):
        scanFunc()
        stdscr.move(51, 0); erase(SCRN_WIDTH); stdscr.refresh()
        stdscr.move(51, 1); stdscr.addstr(" Done scan <ENTER> to go back to Scan Menu: ")
        curses.curs_set(1)
        var = stdscr.getstr()
        curses.curs_set(0)
        keyhit =""
        for x in range(0, 52): 
          stdscr.move(x, 0); erase(139)              
        stdscr.refresh()
        break

      getDevList()
      bListChange = ctypes.c_ubyte; bListChange = 0
      for x in range(0, 31):
        if(psDevListSave[x] != psDevListNew[x]):
          bListChange = 1
          psDevListNew[x] = psDevListSave[x] 
      if(bListChange == 1):
        return (0)
      getDevConnectStat()
      if(initDone == 0): return 0



#===================================================================================
#===================================================================================
#=======  O T H E R   F U N C T I O N S    =========================================
#===================================================================================
#===================================================================================

def erase(n):                    
  for x in range(0, n):
     stdscr.addstr(" ")


def doReset():
  global LL_USB_Lib
  #not implemented with EX_ type functions 
  #BOOLEAN SP_ResetDevice(USHORT usDevID)
  bChan = ctypes.c_ubyte(0)
  LL_USB_Lib.SP_ResetDevice.argtypes = [ctypes.c_ushort]
  LL_USB_Lib.SP_ResetDevice.restypes = ctypes.c_byte
  stdscr.move(39, 0); erase(SCRN_WIDTH); stdscr.move(39, 0);
  stdscr.addstr( "  resetting device - WAIT . . .")
  stdscr.refresh()

  if LL_USB_Lib.SP_ResetDevice(usDevID):
    stdscr.refresh()
  else:
    stdscr.addstr( "  failed  device reset")
    stdscr.refresh()
    return

  pbDigin = ctypes.c_ubyte(0); pbDigin.value = 0
  LL_USB_Lib.EX_SendChan.argtypes = [ctypes.c_ushort, ctypes.c_ubyte, ctypes.POINTER(ctypes.c_ubyte)]
  LL_USB_Lib.EX_SendChan.restypes = ctypes.c_ubyte
  LL_USB_Lib.EX_SendChan(usDevID, bCurChan, pbDigin)
  sleep(1.5)

  stdscr.move(39, 0); erase(SCRN_WIDTH); stdscr.move(39, 0);
  stdscr.addstr( "  successful device reset - WAIT . . .")
  stdscr.refresh()
  sleep(1.5)



def doSysCal():
  global LL_USB_Lib, bCurChan
  #not implemented ->  BOOLEAN EX_SystemCalibration ( void ); 
  #BOOLEAN SP_SystemCalibration(USHORT usDevID, BYTE bCurChan)
  bChan = ctypes.c_ubyte(0)
  LL_USB_Lib.SP_SystemCalibration.argtypes = [ctypes.c_ushort, ctypes.c_ubyte]
  LL_USB_Lib.SP_SystemCalibration.restypes = ctypes.c_byte
  stdscr.move(39, 0); erase(SCRN_WIDTH); stdscr.refresh(); stdscr.move(39, 0)
  stdscr.addstr( "  doing system calibration")
  stdscr.refresh()
  if LL_USB_Lib.SP_SystemCalibration(usDevID, bCurChan):
    sleep(1.5) #required after syscal changes back to original channel
    stdscr.move(39, 0); erase(SCRN_WIDTH); stdscr.refresh(); stdscr.move(39, 0)
    stdscr.addstr( "  successful system calibration")
    stdscr.refresh()
    sleep(.75) #required after syscal changes back to original channel
  else:
    stdscr.move(39, 0); erase(SCRN_WIDTH); stdscr.refresh(); stdscr.move(39, 0)
    stdscr.addstr( "  failed system calibration")
    stdscr.refresh()
    sleep(1.5) 



def doGetActualRate():
  global LL_USB_Lib, fActualRate
  
  #BOOLEAN EX_GetCalculatedRate ( USHORT usDevID , double* pdblRate ); 
  pfActualRateTemp = ctypes.c_double(fRate)

  LL_USB_Lib.EX_GetCalculatedRate.argtypes = [ctypes.c_ushort, ctypes.POINTER(ctypes.c_double)]
  LL_USB_Lib.EX_GetCalculatedRate.restypes = ctypes.c_ubyte
  if (LL_USB_Lib.EX_GetCalculatedRate(usDevID, pfActualRateTemp)):  
    fActualRate = pfActualRateTemp.value
    if(1==2): #for testing
      stdscr.move(39, 0); erase(SCRN_WIDTH); stdscr.refresh(); stdscr.move(39, 0)
      stdscr.addstr( "  checked rate: %f, %lf" % (fRate, float(pfActualRateTemp.value)))
      var = stdscr.getstr()
  else:
    stdscr.move(39, 0);  erase(SCRN_WIDTH); stdscr.refresh(); stdscr.move(39, 0)
    stdscr.addstr( "  failed getting calculated actual rate - <ENTER> to continue: ")
    var = stdscr.getstr()
  curses.curs_set(0)
  stdscr.move(39, 0); erase(SCRN_WIDTH); stdscr.refresh();



def doSendRate():
  global LL_USB_Lib, fRate, initDone, fActualRate, bSendRateQuiet
  #BOOLEAN EX_SendRate(USHORT usDevID, double* dblRate)
  pfRateTemp = ctypes.c_double(0); pfRateTemp.value = fRate
  LL_USB_Lib.EX_SendRate.argtypes = [ctypes.c_ushort, ctypes.POINTER(ctypes.c_double)]
  LL_USB_Lib.EX_SendRate.restypes = ctypes.c_ubyte
  if(bSendRateQuiet == 0):
    while(TRUE):
      stdscr.move(39, 0); erase(SCRN_WIDTH); stdscr.refresh(); stdscr.move(39, 0)
      curses.curs_set(1)
      stdscr.addstr( "enter rate (50-1000): ")
      stdscr.refresh()
      var = stdscr.getstr()
      try: pfRateTemp.value = float(var)
      except: continue
      if((pfRateTemp.value >= 50) and (pfRateTemp.value <= 1000)):
        break
  
    curses.curs_set(0)
    stdscr.move(39, 30); stdscr.addstr( " PENDING  "); stdscr.refresh()
    stdscr.refresh(); stdscr.move(39, 0)
    if(initDone):
      if LL_USB_Lib.EX_SendRate(usDevID, pfRateTemp):  
        fRate = pfRateTemp.value
      else:
        stdscr.addstr( "  failed sending rate - <ENTER> to continue: ")
        stdscr.refresh()
        curses.curs_set(0)
        return
    else:
        fRate = pfRateTemp.value
      
  #BOOLEAN EX_GetCalculatedRate ( USHORT usDevID , double* pdblRate ); 
  pfActualRateTemp = ctypes.c_double(fRate)
  LL_USB_Lib.EX_GetCalculatedRate.argtypes = [ctypes.c_ushort, ctypes.POINTER(ctypes.c_double)]
  LL_USB_Lib.EX_GetCalculatedRate.restypes = ctypes.c_ubyte
  if (LL_USB_Lib.EX_GetCalculatedRate(usDevID, pfActualRateTemp)):  
    fActualRate = pfActualRateTemp.value
  else:
    stdscr.move(39, 0); erase(SCRN_WIDTH); stdscr.refresh(); stdscr.move(39, 0)
    stdscr.addstr( "  failed getting calculated actual rate - <ENTER> to continue: ")
    var = stdscr.getstr()
  curses.curs_set(0)
  stdscr.move(39, 0); erase(SCRN_WIDTH); stdscr.refresh();


    
def doDigin():
  global LL_USB_Lib, bDigin, bDiginRead
  bDiginTemp = ctypes.c_ubyte(0);
  #BOOLEAN BOOLEAN EX_GetDigin(USHORT usDevID, BYTE* bDigIn)
  LL_USB_Lib.EX_GetDigin.argtypes = [ctypes.c_ushort, ctypes.POINTER(ctypes.c_ubyte)]
  LL_USB_Lib.EX_GetDigin.restypes = ctypes.c_ubyte
  stdscr.move(39, 0); erase(SCRN_WIDTH); stdscr.refresh(); stdscr.move(39, 0)
  if LL_USB_Lib.EX_GetDigin(usDevID, bDiginTemp):  
    bDiginRead = 1
    bDigin = bDiginTemp.value
    if((usDevID > 100) and (usDevID < 5000)): bDigin ^= 255  # invert for Model 301 hardware compatibility
    stdscr.addstr("  read digin: %d" % bDigin)
    stdscr.refresh()
  else:
    stdscr.addstr( "  failed reading digital input\n")
    stdscr.refresh()
    return

def doDigout():
  global LL_USB_Lib, bDigout, bDigoutSent
  bDigoutTemp = ctypes.c_ubyte; bDigoutTemp = 0
  if(bIsScanning == 0): bDisplayLineNum = 39 
  else: bDisplayLineNum = 49 

  #BOOLEAN EX_SendDigout(USHORT usDevID, BYTE bDigOut)
  LL_USB_Lib.EX_SendDigout.argtypes = [ctypes.c_ushort, ctypes.c_ubyte]
  LL_USB_Lib.EX_SendDigout.restypes = ctypes.c_ubyte
  while(true):
    stdscr.move(bDisplayLineNum, 0); erase(SCRN_WIDTH); stdscr.refresh(); stdscr.move(bDisplayLineNum, 0)
    stdscr.addstr( "enter digout (0-255): ")
    curses.curs_set(1)
    stdscr.refresh()
    var = stdscr.getstr()
    curses.curs_set(0)
    try: bDigoutTemp = int(var)
    except: continue
    if(bDigoutTemp > 255): continue
    break
  stdscr.move(bDisplayLineNum, 0); erase(SCRN_WIDTH); stdscr.refresh(); stdscr.move(bDisplayLineNum, 0)
  if LL_USB_Lib.EX_SendDigout(usDevID, bDigoutTemp):  
#  if LL_USB_Lib.EX_SendDigout(5530, 2):  
    bDigout = bDigoutTemp
    bDigoutSent = 1
    if(bIsScanning == 0):
      stdscr.addstr("  sent digout: %d" % bDigout)
      stdscr.refresh()
  else:
    if(bIsScanning == 0):
      stdscr.addstr( "  failed sending digital output\n")
      stdscr.refresh()
  curses.curs_set(0)
  return



def doAnalogout():
  global LL_USB_Lib, dblAOut, bDAC, bAnalogSent
  bDisplayLineNum = ctypes.c_ubyte  
  if(bIsScanning == 0): bDisplayLineNum = 39 
  else: bDisplayLineNum = 49 
  
  bDAC_Temp = ctypes.c_ubyte; bDAC_Temp = 0
  dblAnalog_Temp = ctypes.c_double; dblAnalog_Temp = 0
  #BOOLEAN EX_SendDAC(USHORT usDevID, DOUBLE dblVoltage, BYTE bDAC)
  LL_USB_Lib.EX_SendDAC.argtypes = [ctypes.c_ushort, ctypes.c_double, ctypes.c_ubyte]
  LL_USB_Lib.EX_SendDAC.restypes = ctypes.c_ubyte
  while(1==1):
    stdscr.move(bDisplayLineNum, 0); erase(SCRN_WIDTH); stdscr.refresh(); stdscr.move(bDisplayLineNum, 0)
    stdscr.addstr( "enter DAC (0-2): ")
    curses.curs_set(1)
    stdscr.refresh()
    var = stdscr.getstr()
    try: bDAC_Temp = int(var)
    except: continue
    if(bDAC_Temp < 3): break
  while(1==1):
    curses.curs_set(0)
    stdscr.move(bDisplayLineNum, 0); erase(SCRN_WIDTH); stdscr.refresh(); stdscr.move(bDisplayLineNum, 0)
    stdscr.addstr( "enter voltage: (0 to 5.0): ")
    curses.curs_set(1)
    stdscr.refresh()
    var = stdscr.getstr()
    try: dblAnalog_Temp = float(var)
    except: continue
    if((dblAnalog_Temp < 0) or (dblAnalog_Temp > 5)): continue
    break
  curses.curs_set(0)
  stdscr.move(bDisplayLineNum, 0); erase(SCRN_WIDTH); stdscr.refresh(); stdscr.move(bDisplayLineNum, 0)
  if LL_USB_Lib.EX_SendDAC(usDevID, dblAnalog_Temp, bDAC_Temp):  
    bDAC = bDAC_Temp
    dblAOut = dblAnalog_Temp
    bAnalogSent = 1
    if(bIsScanning == 0):
      stdscr.addstr("  sent analog: %1.3f to DAC: %u" % (dblAOut, bDAC))
      stdscr.refresh()
  else:
    if(bIsScanning == 0):
      stdscr.addstr( "  failed sending analog output\n")
      stdscr.refresh()
  curses.curs_set(0)
  return


def doSendChan():
  global LL_USB_Lib, bCurChan, bDigin, bIsScanning

  # scanning placement is different than polled
  bDisplayLineNum = ctypes.c_ubyte  
  if(bIsScanning == 0): bDisplayLineNum = 39 
  else: bDisplayLineNum = 49 
  
  pbDigin = ctypes.c_ubyte(0); pbDigin.value = 0
  bChanTemp = ctypes.c_ubyte; bChanTemp = 0
  #BOOLEAN EX_SendChan(USHORT usDevID, BYTE bChan, BYTE* pbLastDigin)
  LL_USB_Lib.EX_SendChan.argtypes = [ctypes.c_ushort, ctypes.c_ubyte, ctypes.POINTER(ctypes.c_ubyte)]
  LL_USB_Lib.EX_SendChan.restypes = ctypes.c_ubyte
  while(true):
    stdscr.move(bDisplayLineNum, 0); erase(SCRN_WIDTH); stdscr.refresh(); stdscr.move(bDisplayLineNum, 0)
    stdscr.addstr( "enter chan (0-7): ")
    curses.curs_set(1)
    stdscr.refresh()
    var = stdscr.getstr()
    try: bChanTemp = int(var); break
    except: continue
  if(initDone == 0):
    bCurChan = bChanTemp
    stdscr.move(bDisplayLineNum, 0)
    erase(SCRN_WIDTH)
    stdscr.refresh()
    curses.curs_set(0)
    return
  curses.curs_set(0)
  stdscr.move(bDisplayLineNum, 0); erase(SCRN_WIDTH); stdscr.refresh(); stdscr.move(bDisplayLineNum, 0)
  stdscr.addstr( "  sending channel - WAIT . . .")
  stdscr.refresh()
  
  if LL_USB_Lib.EX_SendChan(usDevID, bChanTemp, pbDigin):  
    bCurChan = bChanTemp
    bDigin = pbDigin.value
    stdscr.move(bDisplayLineNum, 0); erase(SCRN_WIDTH); stdscr.refresh(); stdscr.move(bDisplayLineNum, 0)
    if(bIsScanning):
      stdscr.move(3, 17)
      stdscr.addstr("%d" % bCurChan)
    else:  
      stdscr.addstr("  sent chan: %d" % bCurChan)
    stdscr.refresh()
  else:
    stdscr.move(bDisplayLineNum, 0); erase(SCRN_WIDTH); stdscr.refresh(); stdscr.move(bDisplayLineNum, 0)
    stdscr.addstr( "  failed sending channel\n")
    stdscr.refresh()
  curses.curs_set(0)
  return


def doGetConv():
  global LL_USB_Lib, bCurChan
  dblMilliVolts = ctypes.c_double(100)
  LL_USB_Lib.EX_GetOneConversion.argtypes = [ctypes.c_ushort, ctypes.POINTER(ctypes.c_double)]
  LL_USB_Lib.EX_GetOneConversion.restypes = ctypes.c_ubyte
  LL_USB_Lib.EX_GetOneConversion(usDevID, dblMilliVolts)  
  stdscr.move(39, 0); stdscr.clrtoeol() #erase(SCRN_WIDTH)
  stdscr.refresh(); stdscr.move(39, 0)
  if LL_USB_Lib.EX_GetOneConversion(usDevID, dblMilliVolts):  
    #print ("  got volts chan6: %f" % (dblMilliVolts.value / 1000));
    stdscr.addstr("  got volts chan%d: %f ANY KEY " % ((bCurChan),(dblMilliVolts.value / 1000)))
    stdscr.refresh()
    msvcrt.getch() #7-21-23
  else:
    stdscr.addstr( "  failed reading conversion\n")
    stdscr.refresh()
    return



def doInit():
  global LL_USB_Lib, usDevID, initDone
  global bSendRateQuiet, fRate, bCurChan
  
  os.system("cls")
  stdscr.move(2, 0); erase(SCRN_WIDTH)
  stdscr.addstr("\nconnecting - wait . . ."); stdscr.refresh()

  
  LL_USB_Lib.EX_ConnectOneDevice.argtypes = [ctypes.c_ushort, ctypes.c_double, ctypes.c_ubyte]
  LL_USB_Lib.EX_ConnectOneDevice.restypes = ctypes.c_byte
  print ("\nsigning on (may take a while) - WAIT . . ."); stdscr.refresh()
  bRetVal = ctypes.c_ubyte; bRetVal = 0
  #bCurChan = 0

  keyhit =""
  if (LL_USB_Lib.EX_ConnectOneDevice(usDevID, fRate, bCurChan)):
    bSendRateQuiet =  1 
    doSendRate()
    bSendRateQuiet =  0
    initDone = true
    print ("  signed on");
    return
  else:
    print ("  not signed on")
    sleep(1.5)
    print ("  any key to continue: ")
    var = stdscr.getch()
    return



def getDevID():
  global usDevID, initDone
  bGotValidDev = ctypes.c_ubyte; bGotValidDev = 0

  # force reinit if device ID changed 
  usDevID_temp = ctypes.c_ushort; bGotValidDev = 0 
  usDevID_temp = 0 
  
  while(true):
    stdscr.move(39, 0); erase(SCRN_WIDTH)
    stdscr.refresh(); stdscr.move(39, 0)
    stdscr.addstr( "Please enter a \"valid\" Device ID\n  or type \"x\" to return to menu: ")
    curses.curs_set(1)
    stdscr.refresh()
    var = stdscr.getstr()
    if((var == 'x') or (var == 'X')): break
    try: usDevID_temp = int(var) 
    except: continue
    curses.curs_set(0)
    psDevList=(ctypes.c_ushort*32)()
    uiUnused = ctypes.c_uint; uiUnused = 0

    if(usDevID_temp != usDevID): 
      usDevID = usDevID_temp 
      if(initDone):
        initDone = 0
        stdscr.move(40, 0); erase(SCRN_WIDTH); stdscr.refresh();
        stdscr.move(39, 0); erase(SCRN_WIDTH); stdscr.refresh(); stdscr.move(39, 0); 
        stdscr.addstr(" New device ID entered\n Reinitialization needed <ENTER> to continue")
        stdscr.refresh(); curses.curs_set(1)
        var = stdscr.getstr()
        curses.curs_set(0)
        stdscr.move(39, 0); erase(SCRN_WIDTH); 
        stdscr.move(40, 0); erase(SCRN_WIDTH);
    

    LL_USB_Lib.SP_GetRegDevList.argtypes = [ctypes.POINTER(ctypes.c_ushort), ctypes.c_uint]
    LL_USB_Lib.SP_GetRegDevList.restypes = ctypes.c_ubyte
    if(LL_USB_Lib.SP_GetRegDevList(psDevList, uiUnused)):
      for x in range(0, 31):
        if(usDevID == psDevList[x]):
          bGotValidDev = 1
          break
      if(bGotValidDev):
        break
      else: usDevID = 0
      stdscr.move(27, 0); erase(SCRN_WIDTH); stdscr.refresh(); stdscr.move(27, 0)
      stdscr.addstr( "Dev IDs found:  ")
      bFirstVal = ctypes.c_ubyte; bFirstVal = 1
      for x in range(0, 31):
        #NOTE: registry keeps track of devices added and removed. Removed devices have 
        # bit set (reason for test of 0x8000), and the function called presets list to
        # all zeroes: the reason for the two tests below to get actual connected devices
        if( ((psDevList[x] & 0x8000) != 0x8000) and (psDevList[x] != 0)):
          if(bFirstVal): stdscr.addstr( "%4d" % psDevList[x]); bFirstVal = 0
          else: stdscr.addstr( ", %4d " % psDevList[x])
      stdscr.refresh()
      continue
    else:
      stdscr.move(39, 0); erase(SCRN_WIDTH); stdscr.refresh(); stdscr.move(39, 0)
      stdscr.addstr( "Call to DLL to get device ID list failed - any key to continue: ")
      curses.curs_set(1)
      stdscr.refresh()
      var = stdscr.getstr()

  stdscr.move(27, 0); erase(SCRN_WIDTH); stdscr.refresh(); 
  curses.curs_set(0)



def getDevList():
  global LL_USB_Lib, psDevListSave, psDevListNew
  psDevList=(ctypes.c_ushort*32)()
  uiUnused = ctypes.c_uint
  uiUnused = 0
  #BOOLEAN SP_GetRegDevList(USHORT* usCompleteDevList, UINT uiUnused)
  LL_USB_Lib.SP_GetRegDevList.argtypes = [ctypes.POINTER(ctypes.c_ushort), ctypes.c_uint]
  LL_USB_Lib.SP_GetRegDevList.restypes = ctypes.c_ubyte
  if(LL_USB_Lib.SP_GetRegDevList(psDevList, uiUnused)):
    for x in range(0, 31):
      psDevListSave[x] = psDevList[x]
  else:
    stdscr.move(39, 0); erase(SCRN_WIDTH); stdscr.refresh(); stdscr.move(39, 0)
    stdscr.addstr( "  failed getting list")
    stdscr.refresh()



def getDevConnectStat():
  global initDone
#define DEV_NOT_FOUND         0x0
#define DEV_FOUND             0x1
#define DEV_DISCONNECTED      0x2
#define DEV_ENUMERATED        0x4
#define DEV_READY             0x8
#define DEV_OWNED_BY_ANOTHER  0x10
#define DEV_UNKNOWN_ERR       0x20
    
  psDevList=(ctypes.c_ushort*32)()
  uiUnused = ctypes.c_uint; uiUnused = 0
  bGotValidDev = ctypes.c_ubyte; bGotValidDev = 0
  uiDevStat = (ctypes.c_uint)(0)
  #BOOLEAN SP_GetDevStat(USHORT usDevID, UINT* _uiDevStat)
  LL_USB_Lib.SP_GetDevStat.argtypes = [ctypes.c_ushort, ctypes.POINTER(ctypes.c_uint)]
  LL_USB_Lib.SP_GetDevStat.restypes = ctypes.c_ubyte
  LL_USB_Lib.SP_GetDevStat(usDevID, uiDevStat)

  if((uiDevStat.value & 0x1) != 1):
    stdscr.move(39, 0); erase(SCRN_WIDTH); stdscr.refresh(); stdscr.move(39, 0)
    stdscr.addstr( "device was never connected: %d" % uiDevStat.value)
    sleep(2)
    stdscr.refresh()
    return
  else:
    #7-17-23 test
    if((uiDevStat.value & 0x4) != 0x4):
    #if(1==0):
      #BOOLEAN SP_GetRegDevList(USHORT* usCompleteDevList, UINT uiUnused)
      LL_USB_Lib.SP_GetRegDevList.argtypes = [ctypes.POINTER(ctypes.c_ushort), ctypes.c_uint]
      LL_USB_Lib.SP_GetRegDevList.restypes = ctypes.c_ubyte

      #7-17-23 LL_USB_Lib.SP_GetRegDevList(psDevList, uiUnused)
      #7-17-23 all below new
      
      if LL_USB_Lib.SP_GetRegDevList(psDevList, uiUnused):
        stdscr.move(39, 0); erase(SCRN_WIDTH); stdscr.refresh(); stdscr.move(39, 0)
        stdscr.addstr( "SP_GetRegDevList success - any key")
        stdscr.refresh()
        '''
        msvcrt.getch()
        stdscr.move(39, 0); erase(SCRN_WIDTH); stdscr.refresh(); stdscr.move(39, 0)
        stdscr.addstr( "looking in list for %d, any key" % usDevID)
        stdscr.refresh()
        msvcrt.getch()
      else:
        stdscr.move(39, 0); erase(SCRN_WIDTH); stdscr.refresh(); stdscr.move(39, 0)
        stdscr.addstr( "SP_GetRegDevList failed - any key")
        stdscr.refresh()
        msvcrt.getch()
      '''
      
      for x in range(0, 31):
        if(usDevID == psDevList[x]):
          bGotValidDev = 1
          break
      #7-17-23
      if(bGotValidDev):
      #if(1==0):
        stdscr.move(39, 0); erase(SCRN_WIDTH); stdscr.refresh(); stdscr.move(39, 0)
        #7-17-23 stdscr.addstr( "device now connected but needs re-initialized")
        stdscr.addstr( "device now connected")
        stdscr.refresh()
        sleep(1)
      else:
        stdscr.move(39, 0); erase(SCRN_WIDTH); stdscr.refresh(); stdscr.move(39, 0)
        stdscr.addstr( "your device %d no longer connected " % usDevID)
        initDone = 0
        stdscr.refresh()
        sleep(2)
        stdscr.refresh()
      return
    else:
      puiFlags = (ctypes.c_uint)(0)
      pbLastDigin = (ctypes.c_ubyte)(0)
      bCurChan = ctypes.c_ubyte; bCurChan = 0

      #BOOLEAN SP_CheckPower(USHORT usDevID, BYTE bCurChan, BYTE* pbLastDigin, UINT* puiFlags)
      LL_USB_Lib.SP_CheckPower.argtypes = [ctypes.c_uint, ctypes.c_uint, ctypes.POINTER(ctypes.c_ubyte), ctypes.POINTER(ctypes.c_uint)]
      LL_USB_Lib.SP_CheckPower.restypes = ctypes.c_ubyte
      LL_USB_Lib.SP_CheckPower(usDevID, bCurChan, pbLastDigin, puiFlags)
      stdscr.move(40, 0); erase(SCRN_WIDTH); stdscr.refresh(); stdscr.move(40, 0)
            
      #7-17-23 test
      if(puiFlags.value != 1):
      #if(1==0):
        initDone = 0
        stdscr.move(40, 0); erase(SCRN_WIDTH); stdscr.refresh();
        stdscr.move(39, 0); erase(SCRN_WIDTH); stdscr.refresh(); stdscr.move(39, 0); 
        stdscr.addstr(" You may have lost USB connection or power to this device\n Reinitialization needed <ENTER> to continue")
        stdscr.refresh(); curses.curs_set(1)
        var = stdscr.getstr()
        for x in range(17, 52):
          stdscr.move(x, 0); erase(SCRN_WIDTH)
        curses.curs_set(0)
        stdscr.refresh();


def displayDevList():
  global psDevListSave
  bDevFoundDisplayDone = ctypes.c_uint; bDevFoundDisplayDone = 0
  stdscr.move(39, 0); erase(SCRN_WIDTH); stdscr.refresh(); stdscr.move(39, 0)
  stdscr.addstr( "Dev IDs found:  ")
  stdscr.refresh()
  for x in range(0, 31):
    if( ((psDevListSave[x] & 0x8000) != 0x8000) and (psDevListSave[x] != 0)):
      if(bDevFoundDisplayDone == 0):
        stdscr.addstr( "%4d" % psDevListSave[x])
        bDevFoundDisplayDone = 1
      else:
        stdscr.addstr( ", %4d " % psDevListSave[x])
      stdscr.refresh()



def readConfig():
  global usDevID, fRate, bCurChan
  try:
    f = open("LL_USB.cfg","r")
    idString = "ID="
    rateString = "RATE="
    chanString = "CHAN="

    for line in f:
      if(line.find(idString) == 0):
        usDevID = int(line[3:12])
      if(line.find(rateString) == 0):
        fRate = float(line[5:12])
        if(fRate > 1000): fRate = 1000
      if(line.find(chanString) == 0):
        bCurChan = int(line[5:12])
        if(bCurChan > 7): bCurChan = 7
    f.close()
  except: pass   



def writeConfig():
  global usDevID, fRate, bCurChan
  try:
    f = open("LL_USB.cfg","w")
    f.write("To use this file use the format shown below. First enter the device ID number (replace \n\
the one shown below with your own), followed by the rate you'd like to run, followed by \n\
the channel. All that is really required is the device ID which if entered with nothing \n\
else, will have default values of 100Hz and Channel 7 set by the application. Note that \n\
the  ' = '  sign follows each of the values with no space separation. Invalid entries. \n\
will be either ignored or replaced by default values. \n \n \n") 
    f.write("ID=%d\n" % usDevID)
    f.write("RATE=%4.0lf\n" % fRate)
    f.write("CHAN=%d\n" % bCurChan)
    f.close()
  except: pass   


#===================================================================================
#===================================================================================
#===============     M A I N   M E N U     =========================================
#===================================================================================
#===================================================================================
      
def mainMenu():
  global usDevID, masterDone, initDone, LL_USB_Lib
  global bCurChan, bDigout, bDigoutSent, bDigin, bDiginRead
  global fActualRate, fRate, bAOut, bDAC, bAnalogSent
  global psDevListSave, psDevListNew
  initDone = false
  usDevID = 0

#F:\aaPythonLLabs
  
#  LL_USB_Lib = ctypes.windll.LoadLibrary('.\\LL_USB2k.dll')
#7-17-23 changed this line to new folder
#  LL_USB_Lib = ctypes.windll.LoadLibrary('C:\\aaPythonLLabs\\LL_USB2k.dll')
###  LL_USB_Lib = ctypes.windll.LoadLibrary('C:\\Windows\\LL_USB2k.dll')
#  LL_USB_Lib = ctypes.windll.LoadLibrary('C:\\Windows\\LL_USB2k_64.dll')
  LL_USB_Lib = ctypes.windll.LoadLibrary(os.getcwd() + '\\LL_USB2k_64.dll')
#  LL_USB_Lib = ctypes.windll.LoadLibrary('LL_USB2k_64.dll')
#  LL_USB_Lib = ctypes.windll.LoadLibrary('F:\\\!\!_LLabs\\appRelated\\fromWinXP\\pythonApp\\DEMO30xV1\\LL_USB2k.dll')

#F:\!!_LLabs\appRelated\fromWinXP\pythonApp\DEMO30xV1

  
  readConfig()
  if(usDevID != 0):
    psDevList=(ctypes.c_ushort*32)()
    uiUnused = ctypes.c_uint
    uiUnused = 0
    fFound = ctypes.c_ubyte; fFound = 0
    #BOOLEAN SP_GetRegDevList(USHORT* usCompleteDevList, UINT uiUnused)
    LL_USB_Lib.SP_GetRegDevList.argtypes = [ctypes.POINTER(ctypes.c_ushort), ctypes.c_uint]
    LL_USB_Lib.SP_GetRegDevList.restypes = ctypes.c_ubyte
    if(LL_USB_Lib.SP_GetRegDevList(psDevList, uiUnused)):
      for x in range(0, 31):
        if(usDevID == psDevList[x]):
          fFound = 1; break
    if(fFound == 0):
      getDevList(); displayDevList()
      stdscr.move(35, 0); erase(SCRN_WIDTH); stdscr.refresh(); stdscr.move(35, 0)
      stdscr.addstr( "invalid device ID  \"%d\"  read from config file - <ENTER> to continue" % usDevID)
      curses.curs_set(1); stdscr.refresh()
      var = stdscr.getstr()
      stdscr.move(35, 0); erase(SCRN_WIDTH); stdscr.refresh(); stdscr.move(35, 0)
      usDevID = 0         
    
    doGetActualRate()

  while(masterDone == 0):
    stdscr.clear()
    stdscr.refresh()
    stdscr.move(2, 22); stdscr.addstr("Model 30x USB Data Acquisition System         Version %s " % version)
    stdscr.move(4, 22); stdscr.addstr("------------ MAIN MENU --------------")

    if(initDone == 0):
      stdscr.move(13, 0); erase(SCRN_WIDTH); stdscr.move(13, 22)
    stdscr.refresh()
    getDevList(); displayDevList()
    stdscr.move(7, 22); stdscr.addstr( "Q) Quit Program")
    stdscr.move(9, 22);
    if(usDevID == 0): stdscr.addstr( "D) Device ID (must be done first)   ")
    else: stdscr.addstr( "D) Device ID: %d          " % usDevID)
    stdscr.move(11, 22);
    stdscr.addstr( "R) Set internal data rate: %3.3fHz  " % fActualRate)
    stdscr.move(13, 22);
    stdscr.addstr( "C) Channel %d       " % bCurChan)
    stdscr.move(15, 0); erase(SCRN_WIDTH)  
    stdscr.move(15, 22); stdscr.addstr( "I) Initialize Device")
    stdscr.refresh()

    if(initDone):
      stdscr.move(15, 22); stdscr.addstr( "I) Initialize Device (initialized)") 
      stdscr.move(17, 22); stdscr.addstr( "G) Get one conversion")
      stdscr.move(19, 22);
      if(bDiginRead): stdscr.addstr( "N) Digital input (last read: last read: %d)  %s" % (bDigin, ("{:#010b}  ".format(bDigin))[2:13]))
      else: stdscr.addstr( "N) Digital input                           ")
      stdscr.move(21, 22);
      if(bDigoutSent): stdscr.addstr( "O) Digital output (last sent: %d)   %s " % (bDigout, ("{:#010b}  ".format(bDigout))[2:13]))
      else: stdscr.addstr( "O) Digital output                        ")
      stdscr.move(23, 22);
      if(bAnalogSent): stdscr.addstr( "A) Analog output (last: %1.3f, DAC: %d) " % (dblAOut, bDAC))
      else: stdscr.addstr( "A) Analog output")
      stdscr.move(25, 22); stdscr.addstr( "Y) System Calibration")
      stdscr.move(27, 22); stdscr.addstr( "J) Load conguration")
      stdscr.move(29, 22); stdscr.addstr( "K) Save Configuration")
      stdscr.move(31, 22); stdscr.addstr( "S) Scan Menu")
      stdscr.refresh()

    while (true):  
      keyhit =""
      if msvcrt.kbhit():
        keyhit= msvcrt.getch()
        keyhit = keyhit.upper()
      else:
        if(initDone):
          getDevConnectStat()
      if keyhit == b"D": getDevID(); break
      if keyhit == b"Q": return
      if ((keyhit == b"I") and (usDevID != 0)):
        doInit(); break 
      if keyhit == b"L":
        getDevList()
      if keyhit == b"E":
        doReset(); getDevList(); displayDevList()
      if keyhit == b"J":
        readConfig(); doGetActualRate(); getDevList(); displayDevList(); break
      if keyhit == b"K":
        writeConfig(); getDevList(); displayDevList(); break
      getDevList()
      bListChange = ctypes.c_ubyte; bListChange = 0
      for x in range(0, 31):
        if(psDevListSave[x] != psDevListNew[x]):
          bListChange = 1; psDevListNew[x] = psDevListSave[x] 
      if(bListChange == 1):
        break
      if keyhit == b"R":
        doSendRate(); break
      if keyhit == b"C":
        doSendChan(); break
      if(initDone == 0): continue
      
      if keyhit == b"S":
        scanMenu(); break
      if keyhit == b"G":
        #7-17-23 lines below added
        stdscr.move(39, 0); erase(SCRN_WIDTH)
        stdscr.addstr("  got G here goes - any key ")
        stdscr.refresh()
        msvcrt.getch()
        stdscr.move(39, 0); erase(SCRN_WIDTH)
        stdscr.refresh(); stdscr.move(39, 0)


        doGetConv()

        #7-17-23
        break
        
      if keyhit == b"N":
        doDigin()
        if(bDiginRead): break
      if keyhit == b"O":
        doDigout()
        if(bDigoutSent): break
      if keyhit == b"A":
        doAnalogout()
        if(bAnalogSent): break
      if keyhit == b"Y":
        doSysCal(); getDevList(); displayDevList()
      if(initDone == 0): break 
  return

masterDone = 0     
mainMenu()
stdscr.refresh()
curses.endwin()
os.system("cls")
print ("\nending app - please wait\n\n")


















